from pydantic import BaseModel, conlist
from typing import Optional, List
from wssiham.model.agent.adresse import AdresseHeberge
from wssiham.model.agent.contact import EmailNumero
from datetime import datetime


class InformationHeberge(BaseModel):
    categorieFP: Optional[str]
    codeCivilite: Optional[str]
    codeCorpsOrigine: Optional[str]
    codeEchelonOrigine: Optional[str]
    codeEmploiAffectation: Optional[str]
    codeEtablissement: Optional[str]
    codeGradeOrigine: Optional[str]
    codeOrganismeOrigine: Optional[str]
    codeUOAffectation: Optional[str]
    dateDebutAffectation: Optional[datetime]
    dateEntreeCorps: Optional[datetime]
    dateEntreeGrade: Optional[datetime]
    dateFinAffectation: Optional[datetime]
    libCourtCorpsOrigine: Optional[str]
    libLongAutreOrganisme: Optional[str]
    libLongCivilite: Optional[str]
    libLongCorpsOrigine: Optional[str]
    libLongEtabOrigine: Optional[str]
    libLongGradeOrigine: Optional[str]
    libLongOrganismeOrigine: Optional[str]
    libLongStatutOrigine: Optional[str]
    matricule: str
    nomPatronymique: Optional[str]
    nomUsuel: Optional[str]
    prenom: Optional[str]
    quotiteAffectation: Optional[str]
    statutOrigine: Optional[str]
    temoinRemAcc: Optional[str]
    listeAdresses: Optional[List[AdresseHeberge]]
    listeNumerosMails: Optional[List[EmailNumero]]


class InformationHebergeList(BaseModel):
    informationHeberge: InformationHeberge
