from pydantic import BaseModel, conlist
from typing import Optional
from datetime import datetime


class Nomenclature(BaseModel):
    """
    Représentation d'une nomenclature.
    """
    codeAdministration: Optional[str]
    codeNomenclature: str
    codeRepertoire: str
    dateDebutValiditeNomenclature: Optional[datetime]
    dateFinValiditeNomenclature: datetime
    libCourtNomenclature: str
    libLongNomenclature: str
    temEnseignantGpeHierarchique: Optional[str]
    temEnseignantPIP: Optional[str]
    typeRemuneration: Optional[str]


class NomenclatureList(BaseModel):
    """
    Liste de nomenclatures.
    """
    nomenclatures: conlist(Nomenclature, min_length=1)
