from typing import  Optional
from pydantic import BaseModel
from datetime import datetime


class AdresseUO(BaseModel):
    """
    Représentation d'une adresse pour une unité organisationnelle.
    """
    bisTerAdresse: Optional[str]
    codeAdministration: Optional[str]
    codeDepartementAdresse: str
    codePaysAdresseUO: str
    codePostalAdresseUO: str
    codeUO: str
    communeAdresseUO: str
    complementAdresseUO: Optional[str]
    dateFinUO: datetime
    libLongDepartementAdresse: str
    libLongPaysAdresseUO: str
    libLongTypeAdresseUO: str
    natureVoieAdresseUO: Optional[str]
    noVoieAdresseUO: str
    nomVoieAdresse: str
    typeAdresseUO: str
    villeAdresse: Optional[str]


class UniteFille(BaseModel):
    """
    Représentation d'une unité fille pour une unité organisationnelle.
    """
    codeAdministration: Optional[str]
    codeTypeArborescence: str
    codeUOfille: str
    libLongUOFille: str
    libTypeArborescence: str


class UniteMere(BaseModel):
    """
    Représentation d'une unité mère pour une unité organisationnelle.
    """
    codeAdministration: Optional[str]
    codeTypeArborescence: str
    codeUO: str
    codeUOMere: str
    libLongUOMere: str
    libTypeArborescence: str


class UniteOrganisationnelle(BaseModel):
    """
    Représentation d'une unité organisationnelle.
    """
    codeAdministration: Optional[str]
    codeEtablissementUO: str
    codeEtatValidationUO: str
    codeStructureNiv2: str
    codeTypeArborescence: str
    codeTypeUO: str
    codeUO: str
    dateDebutValiditeUO: datetime
    dateFermetureUO: datetime
    dateOuvertureUO: datetime
    libCourtUO: str
    libLongEtatValidationUO: str
    libLongStructureNiv2: str
    libLongTypeArborescence: str
    libLongTypeUO: str
    libLongUO: str
    libStatutUO: str
    listeAdressesUO: list[AdresseUO]
    listeCoordonneesUO: list[dict]
    listeMatriculesResponsablesUO: list[dict]
    matriculeResponsableUO: Optional[str]
    niveauUO: int
    structureUO: str
    unitesFilles: list[UniteFille]
    unitesMeres: list[UniteMere]